// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: StatisticElement
// Author: Hassan Siddiqui
//
// Description: Stores position and value of data element. Used by Statistic class.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: StatisticElement.cc,v 1.3 2000/06/29 15:08:08 hsiddiqu Exp $

/* SAS-specific */
#include "Tracer.h"

/* Local */
#include "StatisticElement.h"

/* Constructors */
StatisticElement::StatisticElement():
  _position(0),_value(0){PROC; ENDPROC;};

StatisticElement::StatisticElement (const unsigned long position, 
				    const double value): 
  _position(position), _value(value)
    {PROC; ENDPROC;}
  
/* Accessors */
const unsigned long StatisticElement::position() const 
{PROC; RETURN _position;}

const double StatisticElement::value() const           
{PROC; RETURN _value;}

  
/* Assignment operator */
StatisticElement& StatisticElement::operator= 
(const StatisticElement& element2)
{
  PROC;
  
  /* Equality check */
  if ( _position == element2.position() && _value == element2.value() )
  {
    ALTRETURNV(*this);
  }
  
  _position = element2.position();
  _value = element2.value();

  RETURN *this;
  
}

/* Output stream function */

void StatisticElement::write(ostream& stream) const
{
  PROC;
  
  stream << "position " << _position << " value " << _value << endl;
	  
  ENDPROC;
}


/* Comparison operators */

bool operator > (const StatisticElement& element1, 
		 const StatisticElement& element2)
{
  PROC;
  
  if (element1.value() > element2.value()) ALTRETURNV(true);
  
  RETURN false;
}

bool operator < (const StatisticElement& element1, 
		 const StatisticElement& element2)
{
  PROC;
  
  if (element1.value() < element2.value()) ALTRETURNV(true);
  
  RETURN false;
}



/* I/O Stream functions */
ostream & operator << ( ostream & stream, 
			const StatisticElement & element)
{
  PROC;

  element.write(stream);

  RETURN stream;
};
