// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: StatisticElement
// Author: Hassan Siddiqui
//
// Description: Stores position and value of data element. Used by Statistic class.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: StatisticElement.h,v 1.4 2000/06/29 15:08:08 hsiddiqu Exp $

#ifndef STATISTICELEMENT_H
#define STATISTICELEMENT_H

/* Utility */
#include "Tracer.h"

//-----------------------------------------------------------------
// class StatisticElement

// Stores position and value of data element. Used by Statistic class.

// NOTE: Through implicit type promotions to double, any numeric input type is accommodated.

//-----------------------------------------------------------------

class StatisticElement
{
public:

  /* Constructors */
  StatisticElement();

  StatisticElement ( const unsigned long position, 
		     const double value);

  /* Accessors */
  const unsigned long position() const;
  const double value() const;

    /* Assignment operator */
  StatisticElement& operator=(const StatisticElement& element2);

  /* Output stream method */
  void write(ostream & stream) const;

private:

  unsigned long _position;
  double _value;

};

/* Comparison operators */
bool operator>(const StatisticElement& element1, 
	       const StatisticElement& element2);

bool operator<(const StatisticElement& element1, 
	       const StatisticElement& element2);


/* I/O Stream functions */
ostream & operator<<(ostream & stream, 
		     const StatisticElement& element);

#endif
